#include <iostream>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <iostream>
#include <string>

using namespace std;

#define RELAYBUFSIZE 10000000

int main(int argc, char **argv)
{
  int fd=open(argv[1], O_RDONLY);
  if(fd < 0) {
    perror("open");
    exit(1);
  }
  char *obuffer=(char*) mmap(0, RELAYBUFSIZE, PROT_READ, MAP_PRIVATE, fd, 0);
  if(obuffer==(char*)-1) {
    perror("mmap");
    exit(1);
  }
  
  char *buffer=new char[RELAYBUFSIZE];
  memcpy(buffer, obuffer, RELAYBUFSIZE);

#if 0
  int err=write(1, buffer, RELAYBUFSIZE);
  if(err < 0)
    perror("write");
  if(err != RELAYBUFSIZE)
    fprintf(stderr, "Partial write!");
#endif


  munmap(obuffer, RELAYBUFSIZE);

  char *pos=buffer;
  char *end=buffer+RELAYBUFSIZE;

  int ret;
  struct timeval tv, lasttv;
  lasttv.tv_sec=0;
  unsigned int linenum=0;

  for(;;) {
    linenum++;
    char *spos=pos;

    while(++pos < end && *pos!='\n')
      ;

    if(pos >= end)
      break;

    ++pos; // skip \n

    string line(spos, pos);
    if(*spos) {

      ret=sscanf(line.c_str(), "%*s %ld %ld", &tv.tv_sec, &tv.tv_usec);
      int msdiff = 1000*(tv.tv_sec - lasttv.tv_sec) + (tv.tv_usec - lasttv.tv_usec)/1000;

      if(ret != 2 || (lasttv.tv_sec && msdiff > 1000)) {
	cerr<<"I think we skipped at "<<linenum<<", ret="<<ret<<endl;
	break;
      }

    }
    lasttv=tv;
  }

  // pos at break
  lasttv.tv_sec=0;
  for(;;) {
    linenum++;
    char *spos=pos;

    while(++pos < end && *pos!='\n')
      ;

    if(pos >= end)
      break;

    ++pos; // skip \n

    string line(spos, pos);
    if(*spos) {
      ret=sscanf(line.c_str(), "%*s %ld %ld", &tv.tv_sec, &tv.tv_usec);
      int msdiff = 1000*(tv.tv_sec - lasttv.tv_sec) + (tv.tv_usec - lasttv.tv_usec)/1000;

      if(ret != 2 || (lasttv.tv_sec && msdiff > 1000)) {
	cerr<<"I think we hit end at "<<linenum<<", ret="<<ret<<endl;
	break;
      }
      else
	write(1, spos, pos-spos);
    }
    lasttv=tv;
  }

  lasttv.tv_sec=0;
  pos=buffer;
  linenum=0;
  for(;;) {
    linenum++;
    char *spos=pos;

    while(++pos < end && *pos!='\n')
      ;

    if(pos >= end)
      break;

    ++pos; // skip \n

    string line(spos, pos);
    if(*spos) {

      ret=sscanf(line.c_str(), "%*s %ld %ld", &tv.tv_sec, &tv.tv_usec);
      int msdiff = 1000*(tv.tv_sec - lasttv.tv_sec) + (tv.tv_usec - lasttv.tv_usec)/1000;

      if(ret != 2 || (lasttv.tv_sec && msdiff > 1000)) {
	cerr<<"I think we hit the break again "<<linenum<<", ret="<<ret<<endl;
	break;
      }
      else
	write(1, spos, pos-spos);
    }
    lasttv=tv;
  }
  

}
